SystemOrganization addCategory: #FuelPresentations!

TestCase subclass: #FuelESUG2011
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MarianoMartinezPeck 8/17/2011 12:22'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello ESUG. The answer is....''.
	a := a , ''42!!!!''.
	Transcript show: a.
	'! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:20'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'testDebugger'.
	newDebugger openFullMorphicLabel: 'This is the new debugger!!'.
! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:24'!
materializePharoDebug
	| aStream newContext |
	"FIRST EDIT logError:  inContext: "
	newContext := FLMaterializer materializeFromFileNamed: 'PharoDebug.fuel'.
	"(Debugger context: newContext)  openFullMorphicLabel: 'This is the new debugger!!'."
	Debugger openContext: newContext label:  'This is the new debugger!!' contents: nil
! !

!FuelESUG2011 classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MarianoMartinezPeck 8/22/2011 16:45'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:22'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:19'!
serializeDebugger

	Smalltalk garbageCollect.
	FLSerializer 
		serialize: (Debugger allInstances first) 
		toFileNamed: 'testDebugger'.
! !

!FuelESUG2011 methodsFor: 'Riak example' stamp: 'MarianoMartinezPeck 8/20/2011 19:56'!
testFuelWithRiak
	| bucket storedObject materializedObject aRectangle client |
	"Before doing this, go to cd /Users/mariano/PhD/riak-0.14.0/bin/ and execute ./riak start "
	client := EpigentRiakClient newForRestConnection: 'http://localhost:8098/riak'.
	aRectangle := Rectangle origin: (4@2) corner: (7@1).
	storedObject := FLSerializer serializeInMemory: aRectangle.
	bucket := client bucketNamed: 'testESUG' .
	bucket atKey: 'test' put: storedObject type: 'application/binary'.
	"Take a browser and go to http://localhost:8098/riak/testESUG/test"
	self halt.
	self assert: (bucket atKey: 'test') = storedObject.
	materializedObject := FLMaterializer materializeFromByteArray: storedObject.
	self assert: materializedObject origin = (4@2).
	self assert: materializedObject corner = (7@1).
! !

!FuelESUG2011 methodsFor: 'Riak example' stamp: 'MarianoMartinezPeck 8/20/2011 19:54'!
testFuelWithSandstoneDB

| commitTime people lookupTime loadTime |
  "  SDFileStore serializer:  SDSmartRefStreamSerializer new."
SDFileStore serializer: SDFuelSerializer new.
SDActiveRecord
   setStore: SDFileStore new;
   warmUpAllClasses.
	"only want to warm up test models, not anything else that might be in this image"
	SDFooObject warmUp.
	SDPersonMock withAllSubclasses do: [ :each | each warmUp ].
	
    people := (1 to: 500) collect: [ :it | SDPersonMock testPerson ].
    commitTime := [ people do: [ :each | each save ] ] timeToRun.
    lookupTime := [ people do: [ :each | SDPersonMock atId: each id ] ] timeToRun.
    loadTime := [
    SDActiveRecord resetStoreForLoad.
    SDPersonMock
        withAllSubclassesDo: [ :each | SDActiveRecord store ensureForClass: each ];
        withAllSubclassesDo: [ :each | each warmUp ].
    SDActiveRecord store ensureForClass: SDFooObject.
    SDFooObject warmUp ] timeToRun.
    Transcript
        show: 'Serialiation time: ', commitTime asString;
        cr;
        show: 'Materialization time: ', loadTime asString;
        cr;
        cr.
    SDPersonMock do: [ :each | [each delete] on: Error do: [] ].
    SDPersonMock coolDown.
    SDFooObject do: [:each | [each delete] on: Error do: [] ].
    SDPersonMock allSubclassesDo: [ :each | each coolDown ].
    Smalltalk garbageCollect
    ! !

TestCase subclass: #FuelESUG2012
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelESUG2012 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello Smalltalks2011. The answer is ''.
	a := a , ''42!!''.
	Transcript show: a.
	'! !

!FuelESUG2012 classSide methodsFor: 'dbxtalk pier' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
exportPierDBXKernel
	| exportTime bytes |
	"IMPORTANT: OPEN A Transcript"
	exportTime := [PRFuelExporterImporter new exportKernelNamed: 'pierDBX' toFilename: 'pierDBX.fuel' ] timeToRun.
	bytes := (FileDirectory default oldFileNamed: 'pierDBX.fuel') size asBytesDescription.
	Transcript show: 'Time to export Pier DBXTalk kernel: ', exportTime asString, ' miliseconds and occupied ', bytes.! !

!FuelESUG2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 8/2/2012 14:54'!
exportSeasidePackagesAllTogether
	| exportTime packages |
	"IMPORTANT: OPEN A Transcript"
	FileStream forceNewFileNamed: 'seasidePierMagritte.fuel' do: [:aStream |
	      aStream binary.
		FLCompiledMethodCluster setTrailerWithNoSource.
		packages := self seasidePackages.
		exportTime := [TAPackageStore new storeInOneBundleSortedPackageNames: packages on: aStream ] timeToRun.
		Transcript show: 'Total time to export ', self seasidePackages size asString, ' packages of Seaside all together: ', exportTime asString, ' miliseconds and occupied ', aStream size asBytesDescription; cr.	
	].


	! !

!FuelESUG2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 8/2/2012 14:58'!
exportSeasidePackagesInDifferentFiles
	|  directory packages timeToExport |
	"IMPORTANT: OPEN A Transcript"
	directory := 'seasidePackages' asFileReference ensureDirectory.
	packages := self seasidePackages.
	timeToExport := [TAPackageStore new storeInDifferentStreamsSortedPackageNames:  packages onDirectory: directory] timeToRun.
	Transcript show: 'Total time to export ', self seasidePackages size asString, ' packages of Seaside in different files: ', timeToExport asString, ' miliseconds'; cr.		! !

!FuelESUG2012 classSide methodsFor: 'dbxtalk pier' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
importPierDBXKernel
	|  importTime bytes |
	"IMPORTANT: OPEN A Transcript"
	importTime := [PRFuelExporterImporter new importNewKernelNamed: 'pierDBX' fromFilename: 'pierDBX.fuel'] timeToRun.
	bytes := (FileDirectory default oldFileNamed: 'pierDBX.fuel') size asBytesDescription.
	Transcript show: 'Time to import Pier DBXTalk kernel: ', importTime asString, ' miliseconds and occupied ', bytes.! !

!FuelESUG2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 8/2/2012 14:54'!
importSeasidePackagesAllTogethers
	| importTime |
	"IMPORTANT: OPEN A Transcript"
	FileStream readOnlyFileNamed: 'seasidePierMagritte.fuel' do: [:aStream | 
		importTime := [TAPackageStore new loadSortedPackagesFromOneBundle: aStream] timeToRun.
		Transcript show: 'Total time to import and initialize Seaside all together: ', importTime asString, ' and occupied ', aStream size asBytesDescription; cr.	
	]
			
		
	! !

!FuelESUG2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 8/2/2012 15:04'!
importSeasidePackagesFromDifferentFiles
	| directory importTime |
	"IMPORTANT: OPEN A Transcript"
	directory := 'seasidePackages' asFileReference.
	importTime := [TAPackageLoader new loadSortedPackagesFromDifferentStreamsInDirectory: directory] timeToRun.
	Transcript show: 'Total time to import and initialize Seaside from different files: ', importTime asString; cr.	 ! !

!FuelESUG2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 8/2/2012 17:56'!
loadSeaside
	Gofer it
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfSeaside30';
	load.

	((Smalltalk at: #ConfigurationOfSeaside30) project version: #stable) load: #('Base' 'Zinc-Seaside' 'Base Tests' 'RSS-Core' 'Javascript-Core' 'Prototype-Core' 'Scriptaculous-Core' 'JQuery-Core' 'JQuery-UI' 'Seaside-Email' 'Seaside-HTML5' 'Seaside-InternetExplorer' 'Seaside-Examples' 'RSS-Examples' 'Seaside-Tools-Web' 'Scriptaculous-Components' 'Seaside-Welcome' 'Seaside-FileSystem' 'RSS-Tests-Core' 'Javascript-Tests-Core' 'Seaside-Tests-Email' 'Seaside-Tests-Functional' 'Prototype-Tests-Core' 'Scriptaculous-Tests-Core' 'Scriptaculous-Tests-Components' 'JQuery-Tests-Core' 'JQuery-Tests-UI' 'Seaside-Tests-HTML5' 'Seaside-Tests-InternetExplorer' 'Seaside-Tests-Examples' 'Seaside-Tests-Tools-Web' 'Seaside-Tests-UTF8' 'Seaside-Tests-FileSystem' 'Seaside-Tests-Welcome').
	
Gofer it
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfPier2';
load.

((Smalltalk at: #ConfigurationOfPier2) project version: #stable) load.


Gofer it
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfPierAddOns2';
load.


((Smalltalk at: #ConfigurationOfPierAddOns2) project version:  #stable) load: #('default' 'Pier-Shout' 'Pier-Design' ).

Gofer it
	squeaksource3: 'pierfuel';
	package: 'Pier-FuelPersistence-Core';
	package: 'Pier-FuelPersistence-Test';
load.
! !

!FuelESUG2012 classSide methodsFor: 'latest error demo' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
materializeAndDebugLatestError
	"FIRST, append the next line at SmalltalkImage>>logError:inContext: 
	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'."
	
	| aContext |
	aContext := FLMaterializer materializeFromFileNamed: 'PharoDebug.fuel'.
	Debugger openContext: aContext label:  'This is the new debugger!!' contents: nil
! !

!FuelESUG2012 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'debugger.fuel'.
	newDebugger openFullMorphicLabel: 'Materialized debugger ;)'.
! !

!FuelESUG2012 classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelESUG2012 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelESUG2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
packagesFromConf: confName version: versionString loading: packageOrGroups
	| loader pkgs |
	
	loader := ((Smalltalk at: confName asSymbol) project version: versionString)
      	ignoreImage: true;
      	record: packageOrGroups.
	pkgs := OrderedCollection new.
	loader loadDirective packageDirectivesDo: [:directive |  pkgs add: directive spec name ].
	^ pkgs ! !

!FuelESUG2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
registerPierKernel
	PRPierFrame
	registerAsApplication: 'pier2'
	kernel: PRDistribution new kernel.
	WADispatcher default
	defaultName: 'pier2'.
! !

!FuelESUG2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 8/2/2012 18:15'!
seasidePackages
	| packages loader |
	packages := OrderedCollection new.
	packages addAll: (self packagesFromConf: #ConfigurationOfSeaside30 version: #stable loading: #('Base' 'Zinc-Seaside' 'Base Tests' 'RSS-Core' 'Javascript-Core' 'Prototype-Core' 'Scriptaculous-Core' 'JQuery-Core' 'JQuery-UI' 'Seaside-Email' 'Seaside-HTML5' 'Seaside-InternetExplorer' 'Seaside-Examples' 'RSS-Examples' 'Seaside-Tools-Web' 'Scriptaculous-Components' 'Seaside-Welcome' 'Seaside-FileSystem' 'RSS-Tests-Core' 'Javascript-Tests-Core' 'Seaside-Tests-Email' 'Seaside-Tests-Functional' 'Prototype-Tests-Core' 'Scriptaculous-Tests-Core' 'Scriptaculous-Tests-Components' 'JQuery-Tests-Core' 'JQuery-Tests-UI' 'Seaside-Tests-HTML5' 'Seaside-Tests-InternetExplorer' 'Seaside-Tests-Examples' 'Seaside-Tests-Tools-Web' 'Seaside-Tests-UTF8' 'Seaside-Tests-FileSystem' 'Seaside-Tests-Welcome'
)).

	packages addAll: (self packagesFromConf: #ConfigurationOfPier2 version: #stable loading: #('default')).
	packages addAll: (self packagesFromConf: #ConfigurationOfPierAddOns2 version: #stable loading: #('default' 'Pier-Shout' 'Pier-Design' )).
	packages addAll: #('Pier-FuelPersistence-Core' 'Pier-FuelPersistence-Test').
	
	packages := packages removeDuplicates.
	
	^ packages
! !

!FuelESUG2012 classSide methodsFor: 'simple demos' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelESUG2012 classSide methodsFor: 'simple demos' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelESUG2012 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
serializeDebugger
	3 timesRepeat: [Smalltalk garbageCollect].
	Smalltalk garbageCollect.
	FLCompiledMethodCluster setTrailerWithSourceCode.
	FLSerializer newFull 
		serialize: Debugger allInstances first
		toFileNamed: 'debugger.fuel'.
! !

!FuelESUG2012 classSide methodsFor: 'latest error demo' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
serializeErrorContext: aContext
	"Send this message from SmalltalkImage>>logError:inContext:"
	FLCompiledMethodCluster setTrailerWithSourceCode.
	FLSerializer newFull 
		serialize: aContext
		toFileNamed: 'PharoDebug.fuel'.
! !

!FuelESUG2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 8/2/2012 14:51'!
startSeaside
	(ZnZincServerAdaptor port: 8888)
	codec: GRPharoUtf8Codec new;
	start.
! !

TestCase subclass: #FuelPharoConf2012
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelPharoConf2012 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 5/10/2012 22:48'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello Smalltalks2011. The answer is ''.
	a := a , ''42!!''.
	Transcript show: a.
	'! !

!FuelPharoConf2012 classSide methodsFor: 'dbxtalk pier' stamp: 'MarianoMartinezPeck 5/22/2012 17:43'!
exportPierDBXKernel
	| exportTime bytes |
	"IMPORTANT: OPEN A Transcript"
	exportTime := [PRFuelExporterImporter new exportKernelNamed: 'pierDBX' toFilename: 'pierDBX.fuel' ] timeToRun.
	bytes := (FileDirectory default oldFileNamed: 'pierDBX.fuel') size asBytesDescription.
	Transcript show: 'Time to export Pier DBXTalk kernel: ', exportTime asString, ' miliseconds and occupied ', bytes.! !

!FuelPharoConf2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/22/2012 17:47'!
exportSeasidePackagesAllTogether
	| exportTime packages |
	"IMPORTANT: OPEN A Transcript"
	FileStream forceNewFileNamed: 'seasidePierMagritte.fuel' do: [:aStream |
	      aStream binary.
		FLCompiledMethodCluster setTrailerWithNoSource.
		packages := self seasidePackages.
		exportTime := [FLPackageStore new storeInOneBundleSortedPackageNames: packages on: aStream ] timeToRun.
		Transcript show: 'Total time to export ', self seasidePackages size asString, ' packages of Seaside all together: ', exportTime asString, ' miliseconds and occupied ', aStream size asBytesDescription; cr.	
	].


	! !

!FuelPharoConf2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/22/2012 16:39'!
exportSeasidePackagesInDifferentFiles
	|  directory packages timeToExport |
	"IMPORTANT: OPEN A Transcript"
	directory := (FileDirectory default directoryNamed: 'seasidePackages') assureExistence.
	packages := self seasidePackages.
	timeToExport := [FLPackageStore new storeInDifferentStreamsSortedPackageNames:  packages onDirectory: directory] timeToRun.
	Transcript show: 'Total time to export ', self seasidePackages size asString, ' packages of Seaside in different files: ', timeToExport asString, ' miliseconds'; cr.		! !

!FuelPharoConf2012 classSide methodsFor: 'dbxtalk pier' stamp: 'MarianoMartinezPeck 5/22/2012 17:46'!
importPierDBXKernel
	|  importTime bytes |
	"IMPORTANT: OPEN A Transcript"
	importTime := [PRFuelExporterImporter new importNewKernelNamed: 'pierDBX' fromFilename: 'pierDBX.fuel'] timeToRun.
	bytes := (FileDirectory default oldFileNamed: 'pierDBX.fuel') size asBytesDescription.
	Transcript show: 'Time to import Pier DBXTalk kernel: ', importTime asString, ' miliseconds and occupied ', bytes.! !

!FuelPharoConf2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/22/2012 17:47'!
importSeasidePackagesAllTogethers
	| importTime |
	"IMPORTANT: OPEN A Transcript"
	FileStream readOnlyFileNamed: 'seasidePierMagritte.fuel' do: [:aStream | 
		importTime := [FLPackageLoader new loadSortedPackagesFromOneBundle: aStream] timeToRun.
		Transcript show: 'Total time to import and initialize Seaside all together: ', importTime asString, ' and occupied ', aStream size asBytesDescription; cr.	
	]
			
		
	! !

!FuelPharoConf2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/22/2012 16:40'!
importSeasidePackagesFromDifferentFiles
	| directory importTime |
	"IMPORTANT: OPEN A Transcript"
	directory := (FileDirectory default directoryNamed: 'seasidePackages').
	importTime := [FLPackageLoader new loadSortedPackagesFromDifferentStreamsInDirectory: directory] timeToRun.
	Transcript show: 'Total time to import and initialize Seaside from different files: ', importTime asString; cr.	 ! !

!FuelPharoConf2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/18/2012 12:40'!
loadSeaside
	Gofer it
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfSeaside30';
	load.

	((Smalltalk at: #ConfigurationOfSeaside30) project version: #stable) load: #('Base' 'Zinc-Seaside' 'Base Tests' 'RSS-Core' 'Javascript-Core' 'Prototype-Core' 'Scriptaculous-Core' 'JQuery-Core' 'JQuery-UI' 'Seaside-Email' 'Seaside-HTML5' 'Seaside-InternetExplorer' 'Seaside-Examples' 'RSS-Examples' 'Seaside-Tools-Web' 'Scriptaculous-Components' 'Seaside-Welcome' 'Seaside-FileSystem' 'RSS-Tests-Core' 'Javascript-Tests-Core' 'Seaside-Tests-Email' 'Seaside-Tests-Functional' 'Prototype-Tests-Core' 'Scriptaculous-Tests-Core' 'Scriptaculous-Tests-Components' 'JQuery-Tests-Core' 'JQuery-Tests-UI' 'Seaside-Tests-HTML5' 'Seaside-Tests-InternetExplorer' 'Seaside-Tests-Examples' 'Seaside-Tests-Tools-Web' 'Seaside-Tests-UTF8' 'Seaside-Tests-FileSystem' 'Seaside-Tests-Welcome').
	
Gofer it
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfPier2';
load.

((Smalltalk at: #ConfigurationOfPier2) project version: '2.0.9') load.


Gofer it
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfPierAddOns2';
load.


((Smalltalk at: #ConfigurationOfPierAddOns2) project version: '2.1.0') load: #('default' 'Pier-Shout' 'Pier-Design' ).

Gofer it
	squeaksource3: 'pierfuel';
	package: 'Pier-FuelPersistence-Core';
	package: 'Pier-FuelPersistence-Test';
load.
! !

!FuelPharoConf2012 classSide methodsFor: 'latest error demo' stamp: 'MarianoMartinezPeck 5/11/2012 12:50'!
materializeAndDebugLatestError
	"FIRST, append the next line at SmalltalkImage>>logError:inContext: 
	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'."
	
	| aContext |
	aContext := FLMaterializer materializeFromFileNamed: 'PharoDebug.fuel'.
	Debugger openContext: aContext label:  'This is the new debugger!!' contents: nil
! !

!FuelPharoConf2012 classSide methodsFor: 'debugger demo' stamp: 'mada 5/10/2012 20:57'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'debugger.fuel'.
	newDebugger openFullMorphicLabel: 'Materialized debugger ;)'.
! !

!FuelPharoConf2012 classSide methodsFor: 'private' stamp: 'mada 5/10/2012 20:57'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelPharoConf2012 classSide methodsFor: 'debugger demo' stamp: 'mada 5/10/2012 20:57'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelPharoConf2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/14/2012 10:15'!
packagesFromConf: confName version: versionString loading: packageOrGroups
	| loader pkgs |
	
	loader := ((Smalltalk at: confName asSymbol) project version: versionString)
      	ignoreImage: true;
      	record: packageOrGroups.
	pkgs := OrderedCollection new.
	loader loadDirective packageDirectivesDo: [:directive |  pkgs add: directive spec name ].
	^ pkgs ! !

!FuelPharoConf2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/14/2012 10:21'!
registerPierKernel
	PRPierFrame
	registerAsApplication: 'pier2'
	kernel: PRDistribution new kernel.
	WADispatcher default
	defaultName: 'pier2'.
! !

!FuelPharoConf2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/18/2012 12:41'!
seasidePackages
	| packages loader |
	packages := OrderedCollection new.
	packages addAll: (self packagesFromConf: #ConfigurationOfSeaside30 version: '3.0.6.3' loading: #('Base' 'Zinc-Seaside' 'Base Tests' 'RSS-Core' 'Javascript-Core' 'Prototype-Core' 'Scriptaculous-Core' 'JQuery-Core' 'JQuery-UI' 'Seaside-Email' 'Seaside-HTML5' 'Seaside-InternetExplorer' 'Seaside-Examples' 'RSS-Examples' 'Seaside-Tools-Web' 'Scriptaculous-Components' 'Seaside-Welcome' 'Seaside-FileSystem' 'RSS-Tests-Core' 'Javascript-Tests-Core' 'Seaside-Tests-Email' 'Seaside-Tests-Functional' 'Prototype-Tests-Core' 'Scriptaculous-Tests-Core' 'Scriptaculous-Tests-Components' 'JQuery-Tests-Core' 'JQuery-Tests-UI' 'Seaside-Tests-HTML5' 'Seaside-Tests-InternetExplorer' 'Seaside-Tests-Examples' 'Seaside-Tests-Tools-Web' 'Seaside-Tests-UTF8' 'Seaside-Tests-FileSystem' 'Seaside-Tests-Welcome'
)).

	packages addAll: (self packagesFromConf: #ConfigurationOfPier2 version: '2.0.9' loading: #('default')).
	packages addAll: (self packagesFromConf: #ConfigurationOfPierAddOns2 version: '2.1.0' loading: #('default' 'Pier-Shout' 'Pier-Design' )).
	packages addAll: #('Pier-FuelPersistence-Core' 'Pier-FuelPersistence-Test').
	
	packages := packages removeDuplicates.
	
	^ packages
! !

!FuelPharoConf2012 classSide methodsFor: 'simple demos' stamp: 'mada 5/10/2012 20:57'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelPharoConf2012 classSide methodsFor: 'simple demos' stamp: 'mada 5/10/2012 20:57'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelPharoConf2012 classSide methodsFor: 'debugger demo' stamp: 'mariano 5/18/2012 19:11'!
serializeDebugger
	3 timesRepeat: [Smalltalk garbageCollect].
	Smalltalk garbageCollect.
	FLCompiledMethodCluster setTrailerWithSourceCode.
	FLSerializer newFull 
		serialize: Debugger allInstances first
		toFileNamed: 'debugger.fuel'.
! !

!FuelPharoConf2012 classSide methodsFor: 'latest error demo' stamp: 'mariano 5/18/2012 19:11'!
serializeErrorContext: aContext
	"Send this message from SmalltalkImage>>logError:inContext:"
	FLCompiledMethodCluster setTrailerWithSourceCode.
	FLSerializer newFull 
		serialize: aContext
		toFileNamed: 'PharoDebug.fuel'.
! !

!FuelPharoConf2012 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/11/2012 15:06'!
startSeaside
	(ZnZincServerAdaptor port: 8888)
	codec: GRPharoUtf8Codec new;
	start.
! !

TestCase subclass: #FuelSmalltalks2011
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MartinDias 11/1/2011 17:14'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello Smalltalks2011. The answer is ''
	a := a , ''42!!''.
	Transcript show: a.
	'! !

!FuelSmalltalks2011 classSide methodsFor: 'latest error demo' stamp: 'MartinDias 11/1/2011 17:20'!
materializeAndDebugLatestError
	"FIRST, append the next line at SmalltalkImage>>logError:inContext: 
	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'."
	
	| aContext |
	aContext := FLMaterializer materializeFromFileNamed: 'LatestError.fuel'.
	Debugger openContext: aContext label:  'This is the new debugger!!' contents: nil
! !

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MartinDias 11/1/2011 17:15'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'debugger.fuel'.
	newDebugger openFullMorphicLabel: 'Materialized debugger ;)'.
! !

!FuelSmalltalks2011 classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelSmalltalks2011 classSide methodsFor: 'simple demos' stamp: 'MarianoMartinezPeck 8/22/2011 16:45'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelSmalltalks2011 classSide methodsFor: 'simple demos' stamp: 'MartinDias 11/1/2011 12:22'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MartinDias 11/1/2011 17:15'!
serializeDebugger

	Smalltalk garbageCollect.
	FLSerializer 
		serialize: Debugger allInstances first
		toFileNamed: 'debugger.fuel'.
! !

!FuelSmalltalks2011 classSide methodsFor: 'latest error demo' stamp: 'MartinDias 11/1/2011 17:21'!
serializeErrorContext: aContext
	"Send this message from SmalltalkImage>>logError:inContext:"

	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'.! !
